package edu.uoc.prezmm.a1list2cook;

import android.app.AlertDialog;
import android.app.ProgressDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.SharedPreferences;
import android.os.Bundle;
import android.support.design.widget.FloatingActionButton;
import android.support.v7.app.AppCompatActivity;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.ImageButton;
import android.widget.ImageView;
import android.widget.ListView;
import android.widget.TextView;

import com.loopj.android.http.AsyncHttpClient;
import com.loopj.android.http.JsonHttpResponseHandler;
import com.loopj.android.http.RequestParams;
import com.squareup.picasso.Picasso;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.util.ArrayList;

import cz.msebera.android.httpclient.Header;
import edu.uoc.prezmm.a1list2cook.objects_class.Recipes;
import edu.uoc.prezmm.a1list2cook.objects_class.Users;

public class RecipesListActivity extends BaseActivity {

    private ArrayList<Recipes> recipesArrayList;

    private RecipesAdapter adapter;
    private ListView recipesList;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        //Defineix el contingut del layout de la Activity dins el frame de la classe pare
        setLayoutToBaseFrame(R.layout.activity_recipes_list);

        setToolBarTitle("Receptes");

        //Estableix el esdeveniment onClick al botó flotant
        FloatingActionButton recipesAdd = (FloatingActionButton)findViewById(R.id.recipesAdd);
        recipesAdd.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                changeActivity(RecipeAddActivity.class);
            }
        });

        //Inicialitzar array de receptes
        recipesArrayList = new ArrayList<Recipes>();

        //Recupera la informació necessaria de l'usuari
        SharedPreferences prefs = getSharedPreferences("UserInfo", Context.MODE_PRIVATE);
        Users userInfo = new Users(prefs);
        String userCode = userInfo.getUserCode();

        //Inicialització dels extres
        String cateCode = null;
        String nameReci = null;

        //Comprova si existeix els Extra idCategoria i reciName
        Intent intent = getIntent();
        if(intent.hasExtra("idCategory")) cateCode = intent.getStringExtra("idCategory");
        if(intent.hasExtra("reciName")) {
            nameReci = intent.getStringExtra("reciName");
            setToolBarTitle("Receptes: resultats cerca");
        }

        //Inicialitza l'array amb el ListView
        adapter = new RecipesAdapter(this);
        recipesList = (ListView)findViewById(R.id.recipesList);

        //Crida a la funció per recuperar les receptes
        getRecipes(userCode,cateCode,nameReci);
    }

   private void getRecipes(String userCode, String cateCode, String nameReci) {
        //Parametres per passar al WebService
        RequestParams params = new RequestParams();
        params.put("userCode", userCode);
       if(cateCode != null && !cateCode.isEmpty()) params.put("cateCode", cateCode);
       if(nameReci != null && !nameReci.isEmpty()) params.put("nameReci", nameReci);

        //Missatge mentre s'està executant el procés de validació
        final ProgressDialog progressDialog = new ProgressDialog(this);

        //Creació de la connecció amb el WebService
        AsyncHttpClient client = new AsyncHttpClient();
        client.get("http://1list2cook.com/webservices/recipes_list.php", params, new JsonHttpResponseHandler() {
           @Override
           public void onStart() {
               progressDialog.setMessage("Recuperant receptes...");
               progressDialog.show();
           }

           @Override
           public void onSuccess(int statusCode, Header[] headers, JSONObject response) {
               progressDialog.dismiss();
               try {
                   JSONObject jsonArray = new JSONObject(response.toString());
                   if (jsonArray.get("success").toString().equalsIgnoreCase("1")) {
                       JSONArray userInfo = new JSONArray(jsonArray.get("message").toString());

                       //Guardar info per generar un nou objecte
                       for(int i = 0; i < userInfo.length(); i++) {
                           String reciCode = userInfo.getJSONObject(i).get("reciIden").toString();
                           String reciCate = userInfo.getJSONObject(i).get("reciCategory").toString();
                           String reciTitl = userInfo.getJSONObject(i).get("reciTitle").toString();
                           String reciText = userInfo.getJSONObject(i).get("reciText").toString();
                           String reciRati = userInfo.getJSONObject(i).get("reciRations").toString();
                           String reciTime = userInfo.getJSONObject(i).get("reciTime").toString();
                           String reciImag = userInfo.getJSONObject(i).get("imagPath").toString();
                           String cateName = userInfo.getJSONObject(i).get("cateName").toString();

                           //Crea el nou objecte amb la informació de la recepta
                           Recipes reciInfo = new Recipes(reciCode, reciTitl, reciText, reciTime, reciRati, reciImag, reciCate, cateName);

                           //Introdueix la recepta a l'array
                           recipeToArray(reciInfo);
                       }
                       //Vincula l'array amb el ListView
                       recipesList.setAdapter(adapter);

                   } else {
                       showMessage(jsonArray.get("message").toString());
                   }
               } catch (JSONException e) {
                   e.printStackTrace();
               }
           }

           @Override
           public void onFailure(int statusCode, Header[] headers, String res, Throwable t) {
               progressDialog.dismiss();
               showMessage("No s'ha pogut gestionar l'operació, intenta-ho de nou. Disculpa les molèsties.");
           }
       });
    }

    //Afegeix una recepta a l'array de receptes
    private void recipeToArray(Recipes recipe) {
        recipesArrayList.add(recipe);
    }

    //Constructor de la classe per l'adaptador
    class RecipesAdapter extends ArrayAdapter<Recipes> {
        AppCompatActivity appCompatActivity;

        RecipesAdapter(AppCompatActivity context) {
            super(context, R.layout.view_recipe, recipesArrayList);
            appCompatActivity = context;
        }

        public View getView(int position, View convertView, ViewGroup parent) {
            LayoutInflater inflater = appCompatActivity.getLayoutInflater();
            View item = inflater.inflate(R.layout.view_recipe, null);

            //Declaració dels elements del View
            ImageView imageView = (ImageView)item.findViewById(R.id.imageView);
            TextView titleText = (TextView)item.findViewById(R.id.titleText);
            TextView descriptionText = (TextView)item.findViewById(R.id.descriptionText);
            Button categoryButton = (Button)item.findViewById(R.id.categoryButton);
            ImageButton deleteButton= (ImageButton)item.findViewById(R.id.deleteButton);

            //Valors dels elements de l'array
            final int idRecipe = recipesArrayList.get(position).getCode();
            String imageRecipe = recipesArrayList.get(position).getImage();
            String titleRecipe = recipesArrayList.get(position).getTitle();
            String descriptionRecipe = recipesArrayList.get(position).getDescription();
            final int idCategory = recipesArrayList.get(position).getCategoryID();
            final String cateName = recipesArrayList.get(position).getCategory();

            //Si es el primer element del array, estableix el títol del ToolBar
            if(position == 0) {
                Intent intent = getIntent();

                if (intent.hasExtra("idCategory") && !intent.hasExtra("reciName")) {
                    setToolBarTitle("Receptes: " + cateName);
                }
            }

            //Omple els elements del View
            if(imageRecipe.length() > 10) Picasso.with(RecipesListActivity.this).load("http://1list2cook.com/uploads/recipes/" + imageRecipe).into(imageView);
            else imageView.setImageResource(R.drawable.recipe_default);
            titleText.setText(titleRecipe);
            descriptionText.setText(descriptionRecipe);
            categoryButton.setText(cateName);

            //Event onClick, canvia a Activity de detall de la recepta, passa com a paràmetre el ID de la recepta
            imageView.setOnClickListener(new View.OnClickListener() {
                public void onClick(View v) {
                    changeActivity(RecipeDetailActivity.class,"idRecipe",String.valueOf(idRecipe));
                }
            });

            //Event onClick que recarrega el Activity passant com a paràmetre el ID de la categoria
            categoryButton.setOnClickListener(new View.OnClickListener() {
                public void onClick(View v) {
                    changeActivity(RecipesListActivity.class,"idCategory",String.valueOf(idCategory));
                }
            });

            //Event onClick permet eliminar la recepta si s'accepta al Dialog
            deleteButton.setOnClickListener(new View.OnClickListener() {
                public void onClick(View v) {
                    deleteRecipe(String.valueOf(idRecipe));
                }
            });

            return(item);
        }
    }

    //Eliminar recepta
    private void deleteRecipe(final String reciCode) {
        AlertDialog.Builder alertDialog = new AlertDialog.Builder(RecipesListActivity.this);

        //Títol del Dialog
        alertDialog.setTitle("Eliminar recepta");

        //Missatge del Dialog
        alertDialog.setMessage("Estàs segur de què vols eliminar la recepta? Si acceptes, serà esborrada permanentment.");

        //Botó per acceptar l'operació
        alertDialog.setPositiveButton("Acceptar", new DialogInterface.OnClickListener() {
            public void onClick(DialogInterface dialog, int which) {
                //Parametres per passar al WebService
                RequestParams params = new RequestParams();
                params.put("reciCode", reciCode);

                //Missatge mentre s'està executant el procés de validació
                final ProgressDialog progressDialog = new ProgressDialog(RecipesListActivity.this);

                //Creació de la connexió amb el WebService
                AsyncHttpClient client = new AsyncHttpClient();
                client.get("http://1list2cook.com/webservices/recipe_delete.php", params, new JsonHttpResponseHandler() {
                    @Override
                    public void onStart() {
                        progressDialog.setMessage("Eliminant recepta...");
                        progressDialog.show();
                    }
                    @Override
                    public void onSuccess(int statusCode, Header[] headers, JSONObject response) {
                        progressDialog.dismiss();
                        try {
                            JSONObject jsonArray = new JSONObject(response.toString());
                            if (jsonArray.get("success").toString().equalsIgnoreCase("1")) {
                                showMessage(jsonArray.get("message").toString());
                                changeActivity(RecipesListActivity.class);
                            }
                        } catch (JSONException e) {
                            e.printStackTrace();
                        }
                    }
                    @Override
                    public void onFailure(int statusCode, Header[] headers, String res, Throwable t) {
                        progressDialog.dismiss();
                        showMessage("No s'ha pogut gestionar l'operació, intenta-ho de nou. Disculpa les molèsties.");
                    }
                });
            }
        });

        //Botó per cancel·lar l'operació
        alertDialog.setNegativeButton("Cancel·lar", new DialogInterface.OnClickListener() {
            public void onClick(DialogInterface dialog, int which) {
                //showMessage("NO OK");
            }
        });

        //Mostra el Dialog
        alertDialog.show();
    }
}
